#include <SoftwareSerial.h>

// Définir les broches du module Bluetooth
SoftwareSerial bluetooth(2, 4); // RX, TX


#define borneENA        5     // On associe la borne "ENA" du L298N à la pin D5 de l'Arduino (PWM possible sur cette broche)
#define borneIN1        3       // On associe la borne "IN1" du L298N à la pin D3 de l'Arduino
#define borneIN2        9       // On associe la borne "IN2" du L298N à la pin D9 de l'Arduino
#define borneIN3        8       // On associe la borne "IN3" du L298N à la pin D8 de l'Arduino
#define borneIN4        7      // On associe la borne "IN4" du L298N à la pin D7 de l'Arduino
#define borneENB        6       // On associe la borne "ENB" du L298N à la pin D6 de l'Arduino (PWM possible sur cette broche)

// Définir les broches des moteurs
//int directionPin = 12;
//int pwmPin = 3;
//int brakePin = 9;

//uncomment if using channel B, and remove above definitions
//int directionPin2 = 13;
//int pwmPin2 = 11;
//int brakePin2 = 8;


void setup() {
  // Configurer les broches des moteurs comme sortie
//pinMode(directionPin, OUTPUT);
//pinMode(pwmPin, OUTPUT);
//pinMode(brakePin, OUTPUT);
//pinMode(directionPin2, OUTPUT);
//pinMode(pwmPin2, OUTPUT);
//pinMode(brakePin2, OUTPUT);
 // Configuration de toutes les pins de l'Arduino en "sortie" (car elles attaquent les entrées du module L298N)
  pinMode(borneENA, OUTPUT);
  pinMode(borneIN1, OUTPUT);
  pinMode(borneIN2, OUTPUT);
  pinMode(borneIN3, OUTPUT);
  pinMode(borneIN4, OUTPUT);
  pinMode(borneENB, OUTPUT);  
  // Initialiser la communication série pour Bluetooth
  bluetooth.begin(9600);
  Serial.begin(9600);
}

void loop() 
{
  if (bluetooth.available()) 
  {
    char commande = bluetooth.read(); // Lire la commande envoyée par Bluetooth

    // Interpréter les commandes envoyées depuis l'application
    switch (commande) {
      case 'A': // Avancer
        avancer();
        Serial.println("Avance");
        break;
      case 'R': // Reculer
        reculer();
        Serial.println("Recule");
        break;
      case 'G': // Tourner à gauche
        tournerGauche();
        Serial.println("gauche");
        break;
      case 'D': // Tourner à droite
        tournerDroite();
        Serial.println("droite");
        break;
      case 'S': // Stop
        stopMotors();
        Serial.println("stop");
        break;
    }
  }
}

// Fonctions de contrôle des moteurs
void avancer() 
{
analogWrite(borneENA, 150);
analogWrite(borneENB, 150);
digitalWrite(borneIN1, HIGH);                 // L'entrée IN1 doit être au niveau haut
digitalWrite(borneIN2, LOW);   
digitalWrite(borneIN3, HIGH);                 // L'entrée IN3 doit être au niveau haut
digitalWrite(borneIN4, LOW); 

}

void reculer() 
{
analogWrite(borneENA, 150);
analogWrite(borneENB, 150);
digitalWrite(borneIN1,LOW);                 // L'entrée IN1 doit être au niveau haut
digitalWrite(borneIN2, HIGH);   
digitalWrite(borneIN3, LOW);                 // L'entrée IN3 doit être au niveau haut
digitalWrite(borneIN4, HIGH); 

}

void tournerGauche() 
{
analogWrite(borneENA, 150);
analogWrite(borneENB, 75);
digitalWrite(borneIN1, HIGH);                 // L'entrée IN1 doit être au niveau haut
digitalWrite(borneIN2, LOW);   
digitalWrite(borneIN3, HIGH);                 // L'entrée IN3 doit être au niveau haut
digitalWrite(borneIN4, LOW); 
}

void tournerDroite() 
{
analogWrite(borneENA, 75);
analogWrite(borneENB, 150);
digitalWrite(borneIN1, HIGH);                 // L'entrée IN1 doit être au niveau haut
digitalWrite(borneIN2, LOW);   
digitalWrite(borneIN3, HIGH);                 // L'entrée IN3 doit être au niveau haut
digitalWrite(borneIN4, LOW); 
}

void stopMotors() 
{
analogWrite(borneENA, 0);
analogWrite(borneENB, 0);
}
